/*
Este codigo te abre y visualiza un archivo 3DS 
en OpenGL, la textura tiene que ser de 512x512
pixels..

Compilado con VisualC++ 6.0, OpenGL y librerias GLUT

Ramiro, bastante sencillo, mmmm libere la memoria??? :-p

Revisado el 31/10/2002

*/

#include <stdlib.h>
#include <stdio.h>
#include <gl/glut.h>
#include <gl/glaux.h>	
#include "textures.h"
#include "3ds.h"

float LightPos[] = { 0.25f, 0.4f, 1.0f, 0.0f};  
float LightAmb[] = { 0.0f, 0.0f, 0.0f, 1.0f}; 
float LightDif[] = { 1.0f, 1.0f, 1.0f, 1.0f};   
float LightSpc[] = { 1.0f, 1.0f, 1.0f, 1.0f};  

char *archivo_3ds="SARA.3DS";
COGLTexture MyTextura;
L3DS    scene;
GLfloat	anguloY=0.0f;

void InitTextures(void)
{
 MyTextura.LoadFromFile("SARA.BMP");
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
}

void init(void)
{
 if (!scene.LoadFile(archivo_3ds))
	{
	 fprintf(stderr, "No puedo abrir el archivo: %s\n", archivo_3ds);
	 exit(1);
	}
 glClearColor(0.0, 0.0, 0.0, 0.0);
 glCullFace(GL_BACK);
 glEnable(GL_DEPTH_TEST);
 glEnable(GL_CULL_FACE);
 glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
 glLightfv(GL_LIGHT0, GL_POSITION, LightPos);     
 glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmb);         
 glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDif);        
 glLightfv(GL_LIGHT0, GL_SPECULAR, LightSpc);       
 glEnable(GL_LIGHT0);                               
 glEnable(GL_LIGHTING);
 InitTextures();
}

void Dibujar3DS(void)
{
 LFace face;
 int i,k;

 for (i=0; i<scene.GetMeshCount(); i++)
    {
    for (k=0; k<scene.GetMesh(i)->GetFaceCount(); k++)
        {
        face = scene.GetMesh(i)->GetFace(k);
        glBegin(GL_TRIANGLES);
		glTexCoord2f(face.uv[0].u,face.uv[0].v);
		glNormal3f(face.normals[0].x, face.normals[0].y, face.normals[0].z);
		glVertex3f(face.vertices[0].x, face.vertices[0].y, face.vertices[0].z);
        glTexCoord2f(face.uv[1].u,face.uv[1].v);
		glNormal3f(face.normals[1].x, face.normals[1].y, face.normals[1].z);
		glVertex3f(face.vertices[1].x, face.vertices[1].y, face.vertices[1].z);
        glTexCoord2f(face.uv[2].u,face.uv[2].v);
		glNormal3f(face.normals[2].x, face.normals[2].y, face.normals[2].z);
		glVertex3f(face.vertices[2].x, face.vertices[2].y, face.vertices[2].z);
		glEnd();
        }
    }
}

void display(void)
{
 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 glLoadIdentity();	
 glEnable(GL_TEXTURE_2D);
 MyTextura.SetActive();
 gluLookAt (0.0, 0.0, 4.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
 glRotatef(anguloY, 0.0f, 1.0f, 0.0f);
 Dibujar3DS();
 glutSwapBuffers();
}


void reshape(int w, int h)
{
 if (!h)
	return;
 glViewport(0, 0,  (GLsizei) w, (GLsizei) h);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();
 gluPerspective(45.0, (GLfloat) w/(GLfloat) h, 1.0, 100.0);
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();
}

void keyboard(unsigned char key, int x, int y)
{
 switch (key)
   {
   case 27: exit(0);
             break;
   }
}

void Idle(void)
{
 anguloY += 1.0;
 display();
}

int main(int argc, char **argv)
{
 glutInit(&argc, argv);
 glutInitWindowSize(400, 400);
 glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
 glutCreateWindow("3DS con Texturas en OpenGL");
 init();
 glutDisplayFunc(display);
 glutReshapeFunc(reshape);
 glutKeyboardFunc(keyboard);
 glutIdleFunc(Idle);
 glutMainLoop();
 return 0;
}
